#include <stdio.h>
#include <stdlib.h>
#include "pz.h"

static PzModule *module;
static PzWidget *wid;
static PzConfig *config;
static ttk_surface image[3];
static int selc, col=0, img=0;
static int w, h, bpp, go=0;
static const char *mode_opt[] = {"Test","Fix",NULL};

static void change_colour()
{
 if(col<8){col++;}
 else if(col>=8){col=0; go=0; pz_close_window(wid->win);}
}

static void pix_do_draw (PzWidget *wid, ttk_surface srf)
{
	ttk_color bg;
	char file[10];

 if(selc==0){
  	if(img>=3){
	switch(img){
		case 3: bg = ttk_makecol(255,0,0);    	break;
		case 4: bg = ttk_makecol(0,255,0);    	break;
		case 5: bg = ttk_makecol(0,0,0);      break;
		case 6: bg = ttk_makecol(0,0,255);     break;
		case 7: bg = ttk_makecol(255,255,255);  break;
		case 8: bg = ttk_makecol(255,0,255);	break;
		case 9: bg = ttk_makecol(255,255,0);	break;
		case 10: bg = ttk_makecol(0,255,255);	break;}

	ttk_fillrect (srf, 0, 0, wid->win->w, wid->win->h, bg);
	}

	else{ttk_blit_image (image[img], srf, 0, 0);}}

else if(selc==1&&go==1){
	 switch(col){
		case 0: bg = ttk_makecol(255,0,0);	break;
		case 1: bg = ttk_makecol(0,255,0);	break;
		case 2: bg = ttk_makecol(0,0,0);	break;
		case 3: bg = ttk_makecol(0,0,255);	break;
		case 4: bg = ttk_makecol(255,255,255);	break;
		case 5: bg = ttk_makecol(255,0,255);	break;
		case 6: bg = ttk_makecol(255,255,0);	break;
		case 7: bg = ttk_makecol(0,255,255);	break;}
	ttk_fillrect (srf, 0, 0, wid->win->w, wid->win->h, bg);
	}
   

}

static int event_pix(PzEvent *e)
{
   
   int ret = TTK_EV_CLICK;
   
   switch (e->type) {
    case PZ_EVENT_SCROLL: //scroll function
	  TTK_SCROLLMOD( e->arg, 10);
		if( e->arg > 0){
			img++;
			if(img>10){img=0;}
			wid->dirty++;
			break;}

		else {	
			img--;
			if(img<0){img=10;}
			wid->dirty++;
			break;}

     case PZ_EVENT_BUTTON_DOWN:
       switch (e->arg) {

     	 case PZ_BUTTON_MENU:
   		 go=0; img=0; col=0;
          	pz_close_window(e->wid->win);
        	break;
	 case PZ_BUTTON_ACTION:
          	go=1;
        	break;
	}

   case PZ_EVENT_TIMER:
		if (selc==1&&go==1){change_colour(); wid->dirty++;}
		break;
   }
   return ret;
}


static void cleanup_pix()
{
   int i;
  for(i=0;i<=2;i++){
    ttk_free_surface(image[i]);}
    go=0; img=0; col=0;
}

static PzWindow *new_pix_window()
{
     PzWindow *ret;

    ret = pz_new_window ("Dead Pixel", PZ_WINDOW_FULLSCREEN); 
    wid = pz_add_widget(ret, pix_do_draw, event_pix);
    pz_widget_set_timer(wid, 100);

    selc = pz_get_int_setting(config, 1); 
    if (selc==1){go=1;}

	int i; char file[5];

   	for(i=0;i<=2;i++){
		sprintf(file, "%d.gif", i);
		image[i]=ttk_load_image (pz_module_get_datapath (module, file));}

    return pz_finish_window (ret);
}

static int save_lcd_config(TWidget *this, int key, int time)
{
	if(key == TTK_BUTTON_MENU){
		pz_save_config(config); 
	}
	return ttk_menu_button(this, key, time);
}

static void init_pix()
{
   	w =ttk_screen->w; 
	h =ttk_screen->h;
	bpp =ttk_screen->bpp;

    module = pz_register_module ("lcd", cleanup_pix);
    config = pz_load_config(pz_module_get_cfgpath(module, "lcd.conf"));
    pz_menu_add_action ("/Extras/Utilities/Dead Pixel/Run", new_pix_window);
    pz_menu_add_setting("/Extras/Utilities/Dead Pixel/Mode", 1, config, mode_opt);
  ((TWidget *)pz_get_menu_item("/Extras/Utilities/Dead Pixel")->data)->button = save_lcd_config;
	   
}

PZ_MOD_INIT(init_pix) 
